/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package www.terasic.com.tw.android.SmartCar_Remote;

import java.math.BigInteger;

import android.R.bool;
import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.RotateAnimation;
import android.view.inputmethod.EditorInfo;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import www.terasic.com.tw.android.SmartCar_Remote.R;

/**
 * This is the main Activity that displays the current chat session.
 */
public class SmartCar extends Activity implements SensorEventListener {
    // Debugging
    private static final String TAG = "SmartCar";
    private static final boolean D = true;

    // Message types sent from the BluetoothChatService Handler
    public static final int MESSAGE_STATE_CHANGE = 1;
    public static final int MESSAGE_READ = 2;
    public static final int MESSAGE_WRITE = 3;
    public static final int MESSAGE_DEVICE_NAME = 4;
    public static final int MESSAGE_TOAST = 5;

    // Key names received from the BluetoothChatService Handler
    public static final String DEVICE_NAME = "device_name";
    public static final String TOAST = "toast";

    // Intent request codes
    private static final int REQUEST_CONNECT_DEVICE_SECURE = 1;
    private static final int REQUEST_CONNECT_DEVICE_INSECURE = 2;
    private static final int REQUEST_ENABLE_BT = 3;

    // Layout Views
    private ListView mConversationView;

    // Name of the connected device
    private String mConnectedDeviceName = null;
    // Array adapter for the conversation thread
    private ArrayAdapter<String> mConversationArrayAdapter;
    // String buffer for outgoing messages
    private static StringBuffer mOutStringBuffer;
    // Local Bluetooth adapter
    private BluetoothAdapter mBluetoothAdapter = null;
    // Member object for the chat services
    private static SmartCarService mChatService = null; 
    //gyro
    float[] vector= new float[3];
    private SensorManager mSensorManager;
    private Sensor mSensor;
    private TextView Gyro_X, Gyro_Y;
    //steering
    ImageView steering;
    private float member = 0;
    private Animation am;
    private TextView steering_value;
    private SeekBar steeringBar;
    
    //light button
    private ImageView lightbutton;
    public boolean lightswitch = false;
    //power button
    private ImageView powerbutton;
    private boolean powerswitch = false;
    //MeasVolBar
    private ProgressBar  MeasVoltageBar;
    private TextView     Voltage;
    
    public static boolean ConnectState = false;
    private static Activity mActivity;
    
    //PID-CAR
   // private ImageView DEMO_PID;
   // public boolean PIDSwitch = false;
    
    //RPM
    Arcs ArcsRPM;
    private TextView  M_h;

    
    
    @SuppressLint("NewApi")
	private void SetSensor() {
        // TODO Auto-generated method stub
    	Gyro_X = (TextView) findViewById(R.id.GX_Value);
        Gyro_Y = (TextView) findViewById(R.id.GY_Value);
        mSensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
        mSensor = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
        mSensorManager.registerListener(this, mSensor, SensorManager.SENSOR_DELAY_NORMAL);
    }
    
    @SuppressLint("NewApi")
	private void SetRotate(float Angle) {
    	Angle = (Angle*10);
        am = new RotateAnimation(member, Angle, Animation.RELATIVE_TO_SELF, 0.5f, Animation.RELATIVE_TO_SELF, 0.5f);
        am.setDuration(2000);
        am.setFillAfter(true);
        steering.setAnimation(am);
        am.startNow(); 
        member = Angle;
        
	
    }
    
    private void IsSeekBarClick(SeekBar seekBar,final TextView seekBarValue){
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener(){  
        int Gprogress = 0;
        @Override  
        public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {  
        // TODO Auto-generated method stub  
        Gprogress = progress;
        if(Gprogress == 0)
            Gprogress = 1;
        seekBarValue.setText("Sensitivity:" +String.valueOf(Gprogress)); 
        }  
  
        @Override  
        public void onStartTrackingTouch(SeekBar seekBar) {  
        // TODO Auto-generated method stub  
        }  
  
        @Override  
        public void onStopTrackingTouch(SeekBar seekBar) {  
        // TODO Auto-generated method stub  
        if(Gprogress == 0)
            Gprogress = 1;

        seekBarValue.setText("Sensitivity:" +String.valueOf(Gprogress)); 
        sendMessage("ATOFA="+Gprogress+"\r");
        }  
        });  
    	
    }
    private void IsSpeaker()
    {
    	steering.setOnClickListener(new OnClickListener(){
         	 public void onClick(View v) {
         		sendMessage("ATSPKER\r");				
         	 }
      });
    }
    
    private void Parsing(String readMessage)
    {
    	 float Data=0; 
    	 int MAX_Battery = 6000;
    	 int MIN_Battery = 4000; 
    	 Data =  Float.parseFloat(readMessage);
    	 Voltage.setText(String.valueOf(Data/1000)+" V"); 
    	 
    	 if(Data>4600)
    	   Voltage.setTextColor(android.graphics.Color.GREEN);
    	 else if(Data<4200 && Data < 4600)
    	   Voltage.setTextColor(android.graphics.Color.YELLOW);
    	 
    	 if(Data > MAX_Battery)
    		 MeasVoltageBar.setProgress(100);
    	 else 
    		 MeasVoltageBar.setProgress(  (int) ((Data-MIN_Battery)/((MAX_Battery -  MIN_Battery)/100)) );
    	 
    	 


    }
    

    private void IsLightButtonClick()
    {
        lightbutton.setOnClickListener(new OnClickListener(){
          	 public void onClick(View v) {
          		if(lightswitch == false){
          			lightswitch = true;
          			sendMessage("ATLON\r");
          	 	    lightbutton.setImageDrawable(getResources().getDrawable(R.drawable.lightbutton_on));
          		}
          		else{
          			lightswitch = false;
          			sendMessage("ATLOFF\r");
          			lightbutton.setImageDrawable(getResources().getDrawable(R.drawable.lightbutton_off));
          		}
          	 }
       });
    }
    

    
    private void IsPowerButtonClick()
    {
        powerbutton.setOnClickListener(new OnClickListener(){
          	 public void onClick(View v) {
          		if(powerswitch == false){
          			powerswitch = true;
          			sendMessage("ATST\r");
          			powerbutton.setImageDrawable(getResources().getDrawable(R.drawable.power_on));
          		}
          		else{
          			sendMessage("ATSP\r");
          			powerswitch = false;
          			powerbutton.setImageDrawable(getResources().getDrawable(R.drawable.power_off));
          		}
          	 }
       });
    }
    
    @Override
    public void onSensorChanged(SensorEvent event) {
     	for(int i=0;i<3;i++)
     		vector[i] = event.values[i];
       Gyro_X.setText("GX : " + String.format("%.2f",vector[0]));
       Gyro_Y.setText("GY : " + String.format("%.2f",vector[1]));
       SetRotate(vector[1]); 
       if(powerswitch==true){
         sendMessage("ATSP="+(int)(vector[0]*-10)+"\r");
         sendMessage("ATOF="+(int)(vector[1]*-10)+"\r");

       }   
        
       float RPMData = Math.abs(vector[0]);
       M_h.setText(String.format("%.2f m/h ",(RPMData*10.2)));
  	   ArcsRPM.mIncSpeedValue = RPMData*10;
  	   ArcsRPM.calcSpeed();
  	   ArcsRPM.mCurrentSpeedValue =  RPMData*10; 	
  	   
    }
	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO Auto-generated method stub
	}
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if(D) Log.e(TAG, "+++ ON CREATE +++");
        // Set up the window layout
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON, WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON); 
        setContentView(R.layout.remote);
        
        //Arcs
        ArcsRPM = (Arcs)findViewById(R.id.Arcs);
        
        // KM/h meas
        M_h = (TextView)findViewById(R.id.KM_Meas);
        
        
        //light button
        lightbutton = (ImageView)findViewById(R.id.image_view_lightbutton);
        IsLightButtonClick();
        
        //power button
        powerbutton = (ImageView)findViewById(R.id.image_view_power_on);
        IsPowerButtonClick();
        
        //BatteryBar
        MeasVoltageBar = (ProgressBar)findViewById(R.id.BatteryBar);
        Voltage        = (TextView) findViewById(R.id.BatteryText);
        Intent intent = new Intent(SmartCar.this, BatteryService.class);
        startService(intent);
        mActivity = this;
        
        //steering
        steering=(ImageView)findViewById(R.id.steering);
        steering_value = (TextView) findViewById(R.id.Sensitivity_Text);
        steeringBar = (SeekBar) findViewById(R.id.SensitivitBar);
        //steering bar
        IsSeekBarClick(steeringBar,steering_value);
        //speaker
        IsSpeaker();
        //Gyro
        SetSensor();
        
        // Get local Bluetooth adapter
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

        // If the adapter is null, then Bluetooth is not supported
        if (mBluetoothAdapter == null) {
            Toast.makeText(this, "Bluetooth is not available", Toast.LENGTH_LONG).show();
            finish();
            return;
        }
    }

    @Override
    public void onStart() {
        super.onStart();
        if(D) Log.e(TAG, "++ ON START ++");

        // If BT is not on, request that it be enabled.
        // setupChat() will then be called during onActivityResult
        if (!mBluetoothAdapter.isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
        // Otherwise, setup the chat session
        } else {
            if (mChatService == null) setupChat();
        }
    }

    @Override
    public synchronized void onResume() {
        super.onResume();
        if(D) Log.e(TAG, "+ ON RESUME +");
        //gyro
        mSensorManager.registerListener(this, mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER), SensorManager.SENSOR_DELAY_NORMAL);
        // Performing this check in onResume() covers the case in which BT was
        // not enabled during onStart(), so we were paused to enable it...
        // onResume() will be called when ACTION_REQUEST_ENABLE activity returns.
        if (mChatService != null) {
            // Only if the state is STATE_NONE, do we know that we haven't started already
            if (mChatService.getState() == SmartCarService.STATE_NONE) {
              // Start the Bluetooth chat services
              mChatService.start();
            }
        }
    }

    private void setupChat() {
        Log.d(TAG, "setupChat()");

        // Initialize the array adapter for the conversation thread
        mConversationArrayAdapter = new ArrayAdapter<String>(this, R.layout.message);
        mConversationView = (ListView) findViewById(R.id.in);
        mConversationView.setAdapter(mConversationArrayAdapter);
        
        // Initialize the BluetoothChatService to perform bluetooth connections
        mChatService = new SmartCarService(this, mHandler);

        // Initialize the buffer for outgoing messages
        mOutStringBuffer = new StringBuffer("");
    }

    @Override
    public synchronized void onPause() {
        super.onPause();
        mSensorManager.unregisterListener(this);
        if(D) Log.e(TAG, "- ON PAUSE -");
    }

    @Override
    public void onStop() {
        super.onStop();
        if(D) Log.e(TAG, "-- ON STOP --");
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        // Stop the Bluetooth chat services
        if (mChatService != null) mChatService.stop();
        if(D) Log.e(TAG, "--- ON DESTROY ---");
        Intent intent = new Intent(SmartCar.this, BatteryService.class);
        stopService(intent);
    }

    private void ensureDiscoverable() {
        if(D) Log.d(TAG, "ensure discoverable");
        if (mBluetoothAdapter.getScanMode() !=
            BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE) {
            Intent discoverableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
            discoverableIntent.putExtra(BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, 300);
            startActivity(discoverableIntent);
        }
    }
   
   public static boolean isBTConnect()
   {
	   return ConnectState;
   }
    
    
    /**
     * Sends a message.
     * @param message  A string of text to send.
     */
     public static void sendMessage(String message) {
        // Check that we're actually connected before trying anything
        if (mChatService.getState() != SmartCarService.STATE_CONNECTED) {
            Toast.makeText(mActivity, R.string.not_connected, Toast.LENGTH_SHORT).show();
            return;
        }

        // Check that there's actually something to send
        if (message.length() > 0) {
            // Get the message bytes and tell the BluetoothChatService to write
            byte[] send = message.getBytes();
            mChatService.write(send);
            
            // Reset out string buffer to zero and clear the edit text field
            mOutStringBuffer.setLength(0);
          //  mOutEditText.setText(mOutStringBuffer);
        }
    }


    @SuppressLint("NewApi")
	private final void setStatus(int resId) {
        final ActionBar actionBar = getActionBar();
        if(actionBar!= null)
        actionBar.setSubtitle(resId);
    }

    @SuppressLint("NewApi")
	private final void setStatus(CharSequence subTitle) {
        final ActionBar actionBar = getActionBar();
        if(actionBar!= null)
        actionBar.setSubtitle(subTitle);
    }

    
    // The Handler that gets information back from the BluetoothChatService
    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
            case MESSAGE_STATE_CHANGE:
                if(D) Log.i(TAG, "MESSAGE_STATE_CHANGE: " + msg.arg1);
                switch (msg.arg1) {
                case SmartCarService.STATE_CONNECTED:
                    setStatus(getString(R.string.title_connected_to, mConnectedDeviceName));
                    mConversationArrayAdapter.clear();
                    ConnectState = true;
                    break;
                case SmartCarService.STATE_CONNECTING:
                    setStatus(R.string.title_connecting);
                    ConnectState = true;
                    break;
                case SmartCarService.STATE_LISTEN: ConnectState = false;
                case SmartCarService.STATE_NONE:ConnectState = false;
                    setStatus(R.string.title_not_connected);
                    break;
                }
                break;
            case MESSAGE_WRITE:
                //byte[] writeBuf = (byte[]) msg.obj;
                // construct a string from the buffer
                //String writeMessage = new String(writeBuf);
               // mConversationArrayAdapter.add("Me:  " + writeMessage);
                break;
            case MESSAGE_READ:
            	String readBuf =  (String) msg.obj;
                // construct a string from the valid bytes in the buffer
                mConversationArrayAdapter.add(mConnectedDeviceName+":  " + readBuf);
                Parsing(readBuf);
                break;
            case MESSAGE_DEVICE_NAME:
                // save the connected device's name
                mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
                Toast.makeText(getApplicationContext(), "Connected to "
                               + mConnectedDeviceName, Toast.LENGTH_SHORT).show();
                break;
            case MESSAGE_TOAST:
                Toast.makeText(getApplicationContext(), msg.getData().getString(TOAST),
                               Toast.LENGTH_SHORT).show();
                break;
            }
        }
    };

    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if(D) Log.d(TAG, "onActivityResult " + resultCode);
        switch (requestCode) {
        case REQUEST_CONNECT_DEVICE_SECURE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                connectDevice(data, true);
            }
            break;
        case REQUEST_CONNECT_DEVICE_INSECURE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                connectDevice(data, false);
            }
            break;
        case REQUEST_ENABLE_BT:
            // When the request to enable Bluetooth returns
            if (resultCode == Activity.RESULT_OK) {
                // Bluetooth is now enabled, so set up a chat session
                setupChat();
            } else {
                // User did not enable Bluetooth or an error occurred
                Log.d(TAG, "BT not enabled");
                Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                finish();
            }
        }
    }

    private void connectDevice(Intent data, boolean secure) {
        // Get the device MAC address
        String address = data.getExtras()
            .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
        // Get the BluetoothDevice object
        BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
        // Attempt to connect to the device
        mChatService.connect(device, secure);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.option_menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Intent serverIntent = null;
        switch (item.getItemId()) {
        case R.id.secure_connect_scan:
            // Launch the DeviceListActivity to see devices and do scan
            serverIntent = new Intent(this, DeviceListActivity.class);
            startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE_SECURE);
            return true;
        }
        return false;
    }

}
