
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE0_NANO_CAR_RTL(

	//////////// CLOCK //////////
	input 		          		CLOCK_50,

	//////////// LED //////////
	output		     [7:0]		LED,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// SW //////////
	input 		     [3:0]		SW,

	//////////// ADC //////////
	output		          		ADC_CS_N,
	output		          		ADC_SADDR,
	output		          		ADC_SCLK,
	input 		          		ADC_SDAT,

	//////////// GPIO_0, GPIO_0 connect to Smart Car Daughtercard //////////
	output		          		BUZZER_OUT,
	output		          		IR_LED_ON,
	input 		          		IR_RXD,
	output		          		LED_LEFT,
	output		          		LED_RIGHT,
	output		          		LTC_ADC_CONVST,
	output		          		LTC_ADC_SCK,
	output		          		LTC_ADC_SDI,
	input 		          		LTC_ADC_SDO,
	output		          		MTRL_N,
	output		          		MTRL_P,
	output		          		MTRR_N,
	output		          		MTRR_P,
	
	input 		          		MTR_Fault_n,
	output		          		MTR_Sleep_n,
	inout 		     [7:0]		TMD0,
	inout 		     [7:0]		TMD1,
	output		          		VCC3P3_PWRON_n
);

//=======================================================
//  REG/WIRE declarations
//=======================================================
 wire       HZ_655 ; 
 wire       ALARM_LED ;  
 wire [7:0] LED_M ; 
 wire       Outlet  ; 
 wire       TRACK_IR;
 wire       TRACK_MUN;
 wire       TRACK_DEMO;
 wire       TRACK ;
 wire       PLAY_IR;
 wire       PLAY_MUN;
 wire       PLAY_DEMO;
 wire       PLAY ;
 wire       START_IR;
 wire       TURN_R_IR; 
 wire       TURN_L_IR; 
 wire       FD_BK;
 wire [15:0]ADC_CN ; 
 wire [15:0]ADC_L0,ADC_L1,ADC_L2 ; 
 wire [15:0]ADC_R0,ADC_R1,ADC_R2; 
 wire       ON_OFF;
 wire       L,R,C;
 wire [7:0] BLINK_L ; 
 wire       HZ_50M  ;
 
 wire       LED_T;   

 wire       MOTOR_L_D; 
 wire       MOTOR_R_D;  
 wire       FORD_D ; 

 wire       OFF_IR ; 
 wire       PLAY_BB ;  
 wire       PLAY_WH ;
 wire       WH_FB;
//=======================================================
//  Structural coding
//=======================================================

//--- SCD MOTOR SLEEP DISABLE ----  
assign MTR_Sleep_n    =1; 
assign IR_LED_ON      =1;
assign VCC3P3_PWRON_n =0; 
//--- SCD 8CH ADC OUTPUT ---- 
ADC_CH_OUT  v( 
   .CLK_50     ( CLOCK_50),		      
   .RESET_N    ( KEY[0]  ) ,	
   .ADC_CONVST ( LTC_ADC_CONVST), 
   .ADC_DIN    ( LTC_ADC_SDI   ),
   .ADC_DOUT   ( LTC_ADC_SDO   ),
   .ADC_SCLK   ( LTC_ADC_SCK   ),
   .CD0	      ( ADC_R2),
   .CD1	      ( ADC_R1),
   .CD2	      ( ADC_R0),		
   .CD3	      ( ADC_CN),
   .CD4	      ( ADC_L0),
   .CD5	      ( ADC_L1),
   .CD6	      ( ADC_L2),
   .CD7	      ( ),
   .SW         ( 4'b0110 ) ,
   .LED        ( LED_M)   //  0~16V / 8  ; 	R1/( R1+R2 )  = 1/4 
);

//--- POWER ON LED-LAMP INITIAL TEST  ----
SELF_TEST   sft1( 
  .CLK_50    ( CLOCK_50 ), 
  .RESET_N   ( 1 ), 
  .LED       ( LED_T ) 
);
//------------------------------------------------------------------
//-- SCD IR  --- 
 IR_CTL  ir (
   .CLOCK_50 (CLOCK_50 ), 
   .OFF      (KEY[0] & KEY[1]   ), 
   .IR_RXD   (IR_RXD   ), 
   .OFF_IR   (OFF_IR   ), 
   .TRACK_IR (TRACK_IR ),
   .PLAY_IR  (PLAY_IR  ),
   .START_IR (START_IR ),
   .TURN_R_IR(TURN_R_IR),
   .TURN_L_IR(TURN_L_IR),
   .FD_BK    (FD_BK    ),
   .SPA_LAMP (SPA_LAMP )
); 


//---------------------------------------------------------------------
MANUAL_CTL  mn(
   .CLOCK_50  (CLOCK_50  ), 
	.OFF       (TRACK_IR  ),     
	.M_D_ON    (KEY[0]    ),       
	.M_SEL     (SW[0]     ),     
	.B_T_ON    (KEY[1]    ),     
   .PLAY_WH   (PLAY_WH   ), 
   .WH_FB     (WH_FB     ), 	
   .TRACK_DEMO(TRACK_DEMO),
   .PLAY_DEMO (PLAY_DEMO ),
   .MOTOR_L_D (MOTOR_L_D ),
   .MOTOR_R_D (MOTOR_R_D ),
   .FORD_D    (FORD_D    ),
   .PLAY_BB   (PLAY_BB   ),	
   .TRACK_MUN (TRACK_MUN ),
   .PLAY_MUN  (PLAY_MUN  )
); 

 //--  TRACK ENABLE -- 
 assign TRACK = TRACK_MUN | TRACK_IR ; 
 
 //--  PLAY ENABLE  -- 
 assign PLAY  = PLAY_MUN  | PLAY_IR  ; 


//--Auto CAR ON---
AUTO_TRACE_ON  rn(
 .RESET_N   (  1 ),
 .CLK       (  CLOCK_50  )  , 
 .ON        (  1 ),
 .OFF       ( ~TRACK | PLAY  ), 
 .ON_OFF    (  ON_OFF  )
); 

//-- Trace_Car & Line_Sensor & Motor Processing --
TRACE_SENSOR_MOTOR  tr( 
 .ADC_CS_N ( LTC_ADC_CONVST ) , 
 .CLK      ( CLOCK_50   ) ,
 .RESET_N  ( 1) ,
 .TR_ON_OFF( ON_OFF),
//LRC OUT
 .L        ( L),
 .R        ( R),
 .C        ( C),  	 
//--ANALOG SENSOR 
 .ADC_CN   ( ADC_CN) ,
 .ADC_L0   ( ADC_L0) , 
 .ADC_R0   ( ADC_R0) ,
 
 .ADC_L1   ( ADC_L1) , 
 .ADC_R1   ( ADC_R1) , 
 .ADC_L2   ( ADC_L2) , 
 .ADC_R2   ( ADC_R2) , 
        
 .M0B      ( MTRL_P),// L_MOTOR
 .M0A      ( MTRL_N),// L_MOTOR
 .M1B      ( MTRR_N),// R_MOTOR  
 .M1A      ( MTRR_P),// R_MOTOR  
 
//--IRDA remote command 
 .TRACK    ( TRACK ) , 
 .START    ( START_IR  | FORD_D  ), 
 .RETURN   ( (PLAY_WH & ~LED_T ) ),  
 .TURN_R   ( WH_FB  | TURN_L_IR | MOTOR_L_D ), 
 .TURN_L   ( WH_FB  | TURN_R_IR | MOTOR_R_D ), 
 .MANU_T   ( PLAY_WH & ~LED_T ), 
 .FD_BK    ( FD_BK ),
 .Outlet   ( Outlet) 
);


//=======GENERATER=======
//-- 655HZ GENERATOR --
SOUND_GEN so(.CLK( CLOCK_50), .CLK_FREQ ( 32'h20000 ),.CK_1HZ( HZ_655 ) ); 

//-- BLINK GENERATOR--- 
BLINK_GEN bk(.CLK( CLOCK_50 ),.BLINK (BLINK_L[7:0] ) );

//-- 1HZ GENERATOR--- 
CLOCKMEM c50(.CLK( CLOCK_50 ),.CLK_FREQ(50000000),.CK_1HZ(HZ_50M) );

//-- ALARM/LED ENABLE-DISABLE-- 
assign ALARM_LED  = ( PLAY_BB & ~LED_T ) | SPA_LAMP |  ( TRACK & Outlet ) ; 	

//-- DE0_NANO LED --- 
assign LED[7:0]   =  
 (  LED_T )?  BLINK_L[7:0]  :  

 (  TRACK |TRACK_DEMO ?
           {{ ( PLAY  |  PLAY_DEMO ) ?  LED_M[7:5]: BLINK_L[2:0] ,
			  1'b0 ,  
			  { L,C,R} } ,
			  HZ_50M | ~KEY[1] | ~KEY[0]  
			  } :
           { 7'h0 , HZ_50M | ~KEY[1] | ~KEY[0] } ) ;  

//--- SCD LED  ----  
assign LED_LEFT   = ALARM_LED ; 
assign LED_RIGHT  = ALARM_LED ; 

//--- SCD BUZZER ---
assign BUZZER_OUT = ( ALARM_LED ) ? HZ_655  :0  ; 

endmodule
