module ANALOG_SENSOR   ( 
  input CLOCK_50 , 
  
//////////// ADC //////////
output		          		ADC_CS_N,
output		          		ADC_SADDR,
output		          		ADC_SCLK,
input 		          		ADC_SDAT,

output  [15:0] ADC_CN ,
output  [15:0] ADC_L0 , 
output  [15:0] ADC_R0 ,
output CK_1M  

  
) ;
wire [15:0] REG0 ,REG2,REG7; 
wire [2:0]  CH0,CH2,CH7 ;

assign CH0 =0 ; 
assign CH2 =2 ; 
assign CH7 =7 ; 

assign REG0  = {  2'h0, CH0[2:0] , 11'h0 };  
assign REG2  = {  2'h0, CH2[2:0] , 11'h0 };  
assign REG7  = {  2'h0, CH7[2:0] , 11'h0 };  


ADC_CTRL	adc(	
 .CK_1M  ( CK_1M  ),
 .RESET_N(1), 
 .CONVST   (), 
 .iCLK    (CLOCK_50),	
 .iCREG0  (REG0),	
 .iCREG2  (REG2),	
 .iCREG7  (REG7),	
 .oADC_D0 (ADC_CN),	
 .oADC_D2 (ADC_L0),	
 .oADC_D7 (ADC_R0),	

 .oDIN   (ADC_SADDR),	
 .oCS_n  (ADC_CS_N),
 .oSCLK  (ADC_SCLK),
 .iDOUT  (ADC_SDAT),
 .ST     (),		
 .COUNTER(),
 .CK_1M () 
);


endmodule 
