module AUTO_TRACE_ON  (
input 	  RESET_N ,
input 	  CLK , 
input 	  ON ,
input 	  OFF,
output reg ON_OFF ,
output reg B_TR  
); 

parameter TIME = 5000*5;

reg [7:0] ST  ; 
reg [31:0]DELAY ; 
reg       rON_OFF ; 
wire      CK_10; 

//--- 0.1us ---
CLOCKMEM v( .CLK(CLK ) ,.CLK_FREQ(5000) ,.CK_1HZ(CK_10) );	

//---
always @( negedge RESET_N  or  posedge CK_10) begin 
if (!RESET_N) begin 
   ST     <=0; 
   ON_OFF <=1;      
   B_TR   <=1; 
	DELAY  <=1; 
end
else begin 
case (ST) 
  0: begin 
     if ( DELAY ==TIME ) begin
          B_TR <=0 ;
          ST   <=1 ;			 
	  end
	  else DELAY <=DELAY+1; 
  end 
  1:begin  //on
      if  ( !OFF )  begin 
		     DELAY  <=0 ;  
		     ST     <=2 ; 
		     ON_OFF <=0;
			  B_TR   <=1 ; 
		end 	  
    end   
  2:begin 
      if  (OFF) begin 
		  if (  DELAY ==TIME ) begin 
		     ON_OFF <=1;      
		     ST     <=1; 
			  B_TR   <=0; 
		   end 	  
		  else DELAY <=DELAY+1; 
	 end 	 
    end     
   endcase
   end
end

endmodule 


