module IR_CTL  (
   input    CLOCK_50 , 
   input    OFF , 
   input    IR_RXD , 
   output   OFF_IR , 
   
   output   TRACK_IR ,
   output   PLAY_IR  ,
   output   START_IR ,
   output   TURN_R_IR,
   output   TURN_L_IR,
   output   FD_BK    ,
   output   SPA_LAMP 
); 

//-- SCD IR OFF  --- 
OFF_CTRL off2(  
   .CLK_50 ( CLOCK_50),  
   .TRACK  ( OFF ),  
   .OFF_N  ( OFF_IR )
) ; 
//-- SCD IR PROCESS  --- 	
IR_PROCESS  irp( 
   .CLOCK_50 ( CLOCK_50 ),   //50MHZ
   .RESET_N  ( OFF_IR   ),   //RESET_n  , LOW PULS
   .IR       ( IR_RXD   ),   //IR PIN
	
   .TRACK    ( TRACK_IR ),   //Tracking function
   .PLAY     ( PLAY_IR  ),   //Start tracking
   .START    ( START_IR ),   //All actions start
   .TURN_R   ( TURN_R_IR),   //Right
   .TURN_L   ( TURN_L_IR),   //Left
   .FD_BK    ( FD_BK    ),   //Forward,Backward
   .SPA_LAMP ( SPA_LAMP )    //Speaking Lamp Trigger
);

endmodule 