module MANUAL_CTL (
   input  CLOCK_50 , 
	input  OFF,      //TRACK_IR
	output OFF_NM, 
	input  M_D_ON,    //KEY[0]
	input  M_SEL,     //SW[0]
	input  B_T_ON,    //B_T_ON	
   output READY_DEMO,
   output PLAY_WH   , 
   output WH_FB     , 	
   output TRACK_DEMO,
   output PLAY_DEMO ,
   output MOTOR_L_D ,
   output MOTOR_R_D ,
   output FORD_D    ,
   output PLAY_BB   ,	
   output TRACK_MUN ,
   output PLAY_MUN  ,
   output READY_NUM 	
); 
//-- SCD Manual OFF --
OFF_CTRL off1 (  
   .CLK_50 ( CLOCK_50 ),  
   .TRACK  ( OFF      ),  
   .OFF_N  ( OFF_NM   )
) ; 

//======
//--Wheel test 
// PRESS KEY[0]  : play short --> STEP
S_WHELL  sws(
 .CLOCK_50 ( CLOCK_50    ) ,
 .START_N  ( M_D_ON      ), 
 .EN       ( ~READY_DEMO ),
 .PLAY     ( PLAY_WH     ),
 .SFB      ( M_SEL       ), //SW[0]=OFF : FORWARD  / SW[0]=ON : BACK
 .OFB      ( WH_FB       )
) ;

// PRESS M_D_ON  : play long  --> DEMO  LEFT /RIGHT 
MANUAL_START_DEMO sm (   
   .CLK_50    ( CLOCK_50  ) , 
   .KEY       ( M_D_ON    ),
   .RESET_N   ( OFF_NM    ), 
   .TRACK     ( TRACK_DEMO) , 
   .PLAY      ( PLAY_DEMO ) , 
   .MOTOR_L_D ( MOTOR_L_D ) , 
   .MOTOR_R_D ( MOTOR_R_D ) ,
   .FORD_D    ( FORD_D    ) ,
   .READY     ( READY_DEMO ) 
) ;

//--BIBI buzzer test 
// PRESS B_T_ON  : play short --> STEP
S_BIBI  bb (
   .CLOCK_50 ( CLOCK_50   ) ,
   .START_N  ( B_T_ON     ), 
   .EN       ( ~READY_NUM ),
   .PLAY     ( PLAY_BB    )
) ; 
// PRESS B_T_ON  : play long  --> DEMO  Trace 
MANUAL_START  stm(  //manual trace 
   .CLK_50  ( CLOCK_50  ) , 
   .KEY     ( B_T_ON    ),
   .RESET_N ( OFF_NM    ), 
   .TRACK   ( TRACK_MUN ) , 
   .PLAY    ( PLAY_MUN  ),
   .READY   ( READY_NUM )  
) ;













endmodule 
