//--- POWER ON TEST --- 
module SELF_TEST  ( 
  input   CLK_50 , 
  input   RESET_N , 
  output  SOUND_LAMP , 
  output  LED , 
  output  MOTOR_L , 
  output  MOTOR_R  ,
  output  RETURN  ,
  output  FORD ,
  output  reg READY 
  
);
wire HZ_500ms ; 

assign  { SOUND_LAMP , LED ,  MOTOR_L ,  MOTOR_R    ,RETURN ,  FORD } =  { S,D,L,R,N ,F  }; 

reg [7:0]ST  ; 
reg S;
reg D;
reg L;
reg R;
reg N ;
reg F  ; 

CLOCKMEM  tim(  .CLK (CLK_50 ),.CLK_FREQ ( 50000000/2 ),.CK_1HZ( HZ_500ms ) ); //-- 500ms 

reg [ 7:0 ] DELAY ;  
always @( negedge RESET_N or posedge HZ_500ms ) begin 
if (!RESET_N) begin  
   ST<=0 ; 
	READY  <=0; 
  { S,D,L,R ,N ,F  } <=6'b0000000; 
end 
else begin 
case (ST ) 
1: begin
       { S,D,L,R ,N ,F  } <=6'b100000; //<--------------------- LAMP /SPEAKER TEST      
       ST <= 2  ; 
	    DELAY <=0; 
end 
0: begin  
	   { S,D,L,R ,N ,F  } <=6'b010000;  //<--------------------- MAINBARD  LED TEST 
		if  ( DELAY == 1 )  ST<=1  ; 
		else  DELAY <=DELAY + 1;  
end 
2: begin 
       ST<= 3  ; 
	   { S,D,L,R ,N ,F  } <=6'b001001;  //<--------------------- L MOTOR  TEST  "+"
end 

3: begin 
   ST<=4  ; 
	  { S,D,L,R ,N ,F  } <=6'b000101;  //<---------------------  R MOTOR  TEST  "+"
end 
4: begin 
   ST<=5  ; 
	  { S,D,L,R ,N ,F  } <=6'b001010;  //<---------------------  L MOTOR  TEST  "-"
end 
5: begin 
   ST<=6  ; 
	  { S,D,L,R ,N ,F  } <=6'b000110;  //<--------------------- R MOTOR  TEST  "-"
end 
6: begin 
   ST<=6  ; 
	  { S,D,L,R ,N ,F  } <=6'b000000;  //<--------------------- TEST  " END "
	  READY  <=1; 
end 


endcase 
end 
end 


endmodule 

   