module IR_DATA_TR (
 input      CLOCK_50  , 
 input      RESET_N , 
 input      IR ,
 output reg IR_LATCH 
 );

parameter IR_LOW_GATE = 450000/2 ; //9ms
parameter IR_HI_GATE  = 4750000 ; //96ms

reg [7:0]  ST ; 			
reg [31:0] IR_TIME_L ; 
reg [31:0] IR_TIME_H ; 
reg [4:0]  CNT ; 

//--IR_RELEASE  		
always @( negedge RESET_N or posedge CLOCK_50 )  begin
if ( !RESET_N )begin 
  IR_LATCH  <=0; 
  IR_TIME_L <=0; 
  IR_TIME_H <=0; 
  CNT       <=0; 
end
else begin
       //-----IR HI 
        if ( IR ) begin 
          if (  IR_TIME_H > IR_HI_GATE )   begin 
			   IR_TIME_L <=0; 
			   IR_LATCH  <=0; 
	       end
	       else IR_TIME_H <= IR_TIME_H + 1  ; 
		//------IR LO
		end 
      else if ( !IR ) begin 
          if (  IR_TIME_L > IR_LOW_GATE )   begin 
			    IR_TIME_H <=0; 
			    IR_LATCH  <=1;
	       end
	       else IR_TIME_L <= IR_TIME_L + 1  ; 
       end
end
end

endmodule
