	component nios_system is
		port (
			adc_ltc2308_conduit_end_convst               : out std_logic;                                       -- convst
			adc_ltc2308_conduit_end_sck                  : out std_logic;                                       -- sck
			adc_ltc2308_conduit_end_sdi                  : out std_logic;                                       -- sdi
			adc_ltc2308_conduit_end_sdo                  : in  std_logic                    := 'X';             -- sdo
			buzzer_external_connection_export            : out std_logic;                                       -- export
			clk_clk                                      : in  std_logic                    := 'X';             -- clk
			dc_motor_left_conduit_end_motor_p            : out std_logic;                                       -- motor_p
			dc_motor_left_conduit_end_motor_n            : out std_logic;                                       -- motor_n
			dc_motor_right_conduit_end_motor_p           : out std_logic;                                       -- motor_p
			dc_motor_right_conduit_end_motor_n           : out std_logic;                                       -- motor_n
			ir_led_on_external_connection_export         : out std_logic;                                       -- export
			ir_rx_conduit_end_export                     : in  std_logic                    := 'X';             -- export
			key_external_connection_export               : in  std_logic_vector(1 downto 0) := (others => 'X'); -- export
			led_external_connection_export               : out std_logic_vector(7 downto 0);                    -- export
			light_left_external_connection_export        : out std_logic;                                       -- export
			light_right_external_connection_export       : out std_logic;                                       -- export
			reset_reset_n                                : in  std_logic                    := 'X';             -- reset_n
			scd_3v3_poweron_n_external_connection_export : out std_logic;                                       -- export
			switch_external_connection_export            : in  std_logic_vector(3 downto 0) := (others => 'X'); -- export
			tmd_status_external_connection_export        : in  std_logic                    := 'X';             -- export
			uart_external_connection_rxd                 : in  std_logic                    := 'X';             -- rxd
			uart_external_connection_txd                 : out std_logic;                                       -- txd
			uart_external_connection_cts_n               : in  std_logic                    := 'X';             -- cts_n
			uart_external_connection_rts_n               : out std_logic                                        -- rts_n
		);
	end component nios_system;

	u0 : component nios_system
		port map (
			adc_ltc2308_conduit_end_convst               => CONNECTED_TO_adc_ltc2308_conduit_end_convst,               --               adc_ltc2308_conduit_end.convst
			adc_ltc2308_conduit_end_sck                  => CONNECTED_TO_adc_ltc2308_conduit_end_sck,                  --                                      .sck
			adc_ltc2308_conduit_end_sdi                  => CONNECTED_TO_adc_ltc2308_conduit_end_sdi,                  --                                      .sdi
			adc_ltc2308_conduit_end_sdo                  => CONNECTED_TO_adc_ltc2308_conduit_end_sdo,                  --                                      .sdo
			buzzer_external_connection_export            => CONNECTED_TO_buzzer_external_connection_export,            --            buzzer_external_connection.export
			clk_clk                                      => CONNECTED_TO_clk_clk,                                      --                                   clk.clk
			dc_motor_left_conduit_end_motor_p            => CONNECTED_TO_dc_motor_left_conduit_end_motor_p,            --             dc_motor_left_conduit_end.motor_p
			dc_motor_left_conduit_end_motor_n            => CONNECTED_TO_dc_motor_left_conduit_end_motor_n,            --                                      .motor_n
			dc_motor_right_conduit_end_motor_p           => CONNECTED_TO_dc_motor_right_conduit_end_motor_p,           --            dc_motor_right_conduit_end.motor_p
			dc_motor_right_conduit_end_motor_n           => CONNECTED_TO_dc_motor_right_conduit_end_motor_n,           --                                      .motor_n
			ir_led_on_external_connection_export         => CONNECTED_TO_ir_led_on_external_connection_export,         --         ir_led_on_external_connection.export
			ir_rx_conduit_end_export                     => CONNECTED_TO_ir_rx_conduit_end_export,                     --                     ir_rx_conduit_end.export
			key_external_connection_export               => CONNECTED_TO_key_external_connection_export,               --               key_external_connection.export
			led_external_connection_export               => CONNECTED_TO_led_external_connection_export,               --               led_external_connection.export
			light_left_external_connection_export        => CONNECTED_TO_light_left_external_connection_export,        --        light_left_external_connection.export
			light_right_external_connection_export       => CONNECTED_TO_light_right_external_connection_export,       --       light_right_external_connection.export
			reset_reset_n                                => CONNECTED_TO_reset_reset_n,                                --                                 reset.reset_n
			scd_3v3_poweron_n_external_connection_export => CONNECTED_TO_scd_3v3_poweron_n_external_connection_export, -- scd_3v3_poweron_n_external_connection.export
			switch_external_connection_export            => CONNECTED_TO_switch_external_connection_export,            --            switch_external_connection.export
			tmd_status_external_connection_export        => CONNECTED_TO_tmd_status_external_connection_export,        --        tmd_status_external_connection.export
			uart_external_connection_rxd                 => CONNECTED_TO_uart_external_connection_rxd,                 --              uart_external_connection.rxd
			uart_external_connection_txd                 => CONNECTED_TO_uart_external_connection_txd,                 --                                      .txd
			uart_external_connection_cts_n               => CONNECTED_TO_uart_external_connection_cts_n,               --                                      .cts_n
			uart_external_connection_rts_n               => CONNECTED_TO_uart_external_connection_rts_n                --                                      .rts_n
		);

