
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE0_NANO_SMART_CAR(


	//////////// CLOCK //////////
	input 		          		CLOCK_50,

	//////////// LED //////////
	output		     [7:0]		LED,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// SW //////////
	input 		     [3:0]		SW,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		     [1:0]		DRAM_DQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_WE_N,

	//////////// Accelerometer and EEPROM //////////
	output		          		G_SENSOR_CS_N,
	input 		          		G_SENSOR_INT,
	output		          		I2C_SCLK,
	inout 		          		I2C_SDAT,

	//////////// GPIO_0, GPIO_0 connect to Smart Car Daughtercard //////////
	output		          		BUZZER_OUT,
	output		          		IR_LED_ON,
	input 		          		IR_RXD,
	output		          		LED_LEFT,
	output		          		LED_RIGHT,
	output		          		LTC_ADC_CONVST,
	output		          		LTC_ADC_SCK,
	output		          		LTC_ADC_SDI,
	input 		          		LTC_ADC_SDO,
	output		          		MTRL_N,
	output		          		MTRL_P,
	output		          		MTRR_N,
	output		          		MTRR_P,
	input 		          		MTR_Fault_n,
	output		          		MTR_Sleep_n,
	inout 		     [7:0]		TMD0,
	inout 		     [7:0]		TMD1,
	output		          		VCC3P3_PWRON_n,
	
			/////////// EPCS //////////
	input        					EPCS_DATA0,
	output       					EPCS_DCLK,
	output       					EPCS_FLASH_nCE,
	output       					EPCS_ASDO,

	//////////// GPIO_1, GPIO_1 connect to LT24 - 2.4" LCD and Touch //////////
	input 		          		LT24_ADC_BUSY,
	output		          		LT24_ADC_CS_N,
	output		          		LT24_ADC_DCLK,
	output		          		LT24_ADC_DIN,
	input 		          		LT24_ADC_DOUT,
	input 		          		LT24_ADC_PENIRQ_N,
	output		          		LT24_CS_N,
	output		    [15:0]		LT24_D,
	output		          		LT24_LCD_ON,
	output		          		LT24_RD_N,
	output		          		LT24_RESET_N,
	output		          		LT24_RS,
	output		          		LT24_WR_N
);



//=======================================================
//  REG/WIRE declarations
//=======================================================
reg  [24:0] count;
wire        Buzzer_Out;
wire [31:0] RPS;
wire [11:0] ADC_Data;


//=======================================================
//  Structural coding
//=======================================================


VOLTAGE_METER  v(
      .CLK_50     (CLOCK_50),		      
		.ADC_CONVST (LTC_ADC_CONVST), 
      .ADC_DIN    (LTC_ADC_SDI),
      .ADC_DOUT   (LTC_ADC_SDO),
      .ADC_SCLK   (LTC_ADC_SCK),
		.RESET_N    (KEY[0]) ,
	   .CD7		   (ADC_Data)
);

//Power always ON
assign VCC3P3_PWRON_n = 0;

//Terasic TMD
assign TMD0[0] = txd;
assign rxd = TMD0[1];
assign TMD0[3] = rts;
assign cts     = TMD0[2];
wire   cts,rts;
wire   rxd,txd;


always@(posedge CLOCK_50)
begin
  count <= count + 1;
end

//Speaker
assign BUZZER_OUT = (count[15]& Buzzer_Out)?1'b1:1'b0;
//don't sleep
assign MTR_Sleep_n = 1'b1;

    Qsys u0 (
        .bts_tmd_external_connection_rxd       (rxd),       //    bts_tmd_external_connection.rxd
        .bts_tmd_external_connection_txd       (txd),       //                               .txd
        .bts_tmd_external_connection_cts_n     (cts),      //                               .cts_n
        .bts_tmd_external_connection_rts_n     (rts),      //                               .rts_n
		  .bts_tmd_connect_state_external_connection_export (TMD0[4]),  // bts_tmd_connect_state_external_connection.export
        .buzzer_out_external_connection_export            (Buzzer_Out),            //            buzzer_out_external_connection.export
        .car_led_external_connection_export               ({LED_LEFT,LED_RIGHT}),               //               car_led_external_connection.export
        .car_voltage_data_external_connection_export      (ADC_Data),      //      car_voltage_data_external_connection.export
        .clk_clk                                          (CLOCK_50),                                          //                                       clk.clk
        .reset_reset_n                                    (1'b1),                                    //                                     reset.reset_n
        .dc_motor_left_conduit_end_motor_p                (MTRL_N),                //                 dc_motor_left_conduit_end.motor_p
        .dc_motor_left_conduit_end_motor_n                (MTRL_P),                //                                          .motor_n
        .dc_motor_right_conduit_end_motor_p               (MTRR_P),               //                dc_motor_right_conduit_end.motor_p
        .dc_motor_right_conduit_end_motor_n               (MTRR_N),                //                                          .motor_n
		  .sdram_wire_addr								(DRAM_ADDR),			// sdram_wire.addr
		  .sdram_wire_ba									(DRAM_BA),				//           .ba
		  .sdram_wire_cas_n								(DRAM_CAS_N),			//           .cas_n
		  .sdram_wire_cke			   					(DRAM_CKE),				//           .cke
		  .sdram_wire_cs_n								(DRAM_CS_N),			//           .cs_n
		  .sdram_wire_dq									(DRAM_DQ),				//           .dq
		  .sdram_wire_dqm			  						(DRAM_DQM),				//           .dqm
		  .sdram_wire_ras_n								(DRAM_RAS_N),			//           .ras_n
		  .sdram_wire_we_n								(DRAM_WE_N),			//           .we_n
      
   	  .altpll_sdram_clk                       (DRAM_CLK),
	
	     .epcs_controller_external_dclk                    (EPCS_DCLK),                    //                  epcs_controller_external.dclk
        .epcs_controller_external_sce                     (EPCS_FLASH_nCE),                     //                                          .sce
        .epcs_controller_external_sdo                     (EPCS_ASDO),                     //                                          .sdo
        .epcs_controller_external_data0                   (EPCS_DATA0),                   //                                          .data0
        .altpll_areset_conduit_export                     (),                     //                     altpll_areset_conduit.export
        .altpll_locked_conduit_export                     (),                     //                     altpll_locked_conduit.export
        .altpll_phasedone_conduit_export                  ()                   //                  altpll_phasedone_conduit.export

	);



endmodule
