	component Qsys is
		port (
			altpll_areset_conduit_export                     : in    std_logic                     := 'X';             -- export
			altpll_locked_conduit_export                     : out   std_logic;                                        -- export
			altpll_phasedone_conduit_export                  : out   std_logic;                                        -- export
			altpll_sdram_clk                                 : out   std_logic;                                        -- clk
			bts_tmd_connect_state_external_connection_export : in    std_logic                     := 'X';             -- export
			bts_tmd_external_connection_rxd                  : in    std_logic                     := 'X';             -- rxd
			bts_tmd_external_connection_txd                  : out   std_logic;                                        -- txd
			bts_tmd_external_connection_cts_n                : in    std_logic                     := 'X';             -- cts_n
			bts_tmd_external_connection_rts_n                : out   std_logic;                                        -- rts_n
			buzzer_out_external_connection_export            : out   std_logic;                                        -- export
			car_led_external_connection_export               : out   std_logic_vector(1 downto 0);                     -- export
			car_voltage_data_external_connection_export      : in    std_logic_vector(11 downto 0) := (others => 'X'); -- export
			clk_clk                                          : in    std_logic                     := 'X';             -- clk
			dc_motor_left_conduit_end_motor_p                : out   std_logic;                                        -- motor_p
			dc_motor_left_conduit_end_motor_n                : out   std_logic;                                        -- motor_n
			dc_motor_right_conduit_end_motor_p               : out   std_logic;                                        -- motor_p
			dc_motor_right_conduit_end_motor_n               : out   std_logic;                                        -- motor_n
			epcs_controller_external_dclk                    : out   std_logic;                                        -- dclk
			epcs_controller_external_sce                     : out   std_logic;                                        -- sce
			epcs_controller_external_sdo                     : out   std_logic;                                        -- sdo
			epcs_controller_external_data0                   : in    std_logic                     := 'X';             -- data0
			reset_reset_n                                    : in    std_logic                     := 'X';             -- reset_n
			sdram_wire_addr                                  : out   std_logic_vector(12 downto 0);                    -- addr
			sdram_wire_ba                                    : out   std_logic_vector(1 downto 0);                     -- ba
			sdram_wire_cas_n                                 : out   std_logic;                                        -- cas_n
			sdram_wire_cke                                   : out   std_logic;                                        -- cke
			sdram_wire_cs_n                                  : out   std_logic;                                        -- cs_n
			sdram_wire_dq                                    : inout std_logic_vector(15 downto 0) := (others => 'X'); -- dq
			sdram_wire_dqm                                   : out   std_logic_vector(1 downto 0);                     -- dqm
			sdram_wire_ras_n                                 : out   std_logic;                                        -- ras_n
			sdram_wire_we_n                                  : out   std_logic                                         -- we_n
		);
	end component Qsys;

	u0 : component Qsys
		port map (
			altpll_areset_conduit_export                     => CONNECTED_TO_altpll_areset_conduit_export,                     --                     altpll_areset_conduit.export
			altpll_locked_conduit_export                     => CONNECTED_TO_altpll_locked_conduit_export,                     --                     altpll_locked_conduit.export
			altpll_phasedone_conduit_export                  => CONNECTED_TO_altpll_phasedone_conduit_export,                  --                  altpll_phasedone_conduit.export
			altpll_sdram_clk                                 => CONNECTED_TO_altpll_sdram_clk,                                 --                              altpll_sdram.clk
			bts_tmd_connect_state_external_connection_export => CONNECTED_TO_bts_tmd_connect_state_external_connection_export, -- bts_tmd_connect_state_external_connection.export
			bts_tmd_external_connection_rxd                  => CONNECTED_TO_bts_tmd_external_connection_rxd,                  --               bts_tmd_external_connection.rxd
			bts_tmd_external_connection_txd                  => CONNECTED_TO_bts_tmd_external_connection_txd,                  --                                          .txd
			bts_tmd_external_connection_cts_n                => CONNECTED_TO_bts_tmd_external_connection_cts_n,                --                                          .cts_n
			bts_tmd_external_connection_rts_n                => CONNECTED_TO_bts_tmd_external_connection_rts_n,                --                                          .rts_n
			buzzer_out_external_connection_export            => CONNECTED_TO_buzzer_out_external_connection_export,            --            buzzer_out_external_connection.export
			car_led_external_connection_export               => CONNECTED_TO_car_led_external_connection_export,               --               car_led_external_connection.export
			car_voltage_data_external_connection_export      => CONNECTED_TO_car_voltage_data_external_connection_export,      --      car_voltage_data_external_connection.export
			clk_clk                                          => CONNECTED_TO_clk_clk,                                          --                                       clk.clk
			dc_motor_left_conduit_end_motor_p                => CONNECTED_TO_dc_motor_left_conduit_end_motor_p,                --                 dc_motor_left_conduit_end.motor_p
			dc_motor_left_conduit_end_motor_n                => CONNECTED_TO_dc_motor_left_conduit_end_motor_n,                --                                          .motor_n
			dc_motor_right_conduit_end_motor_p               => CONNECTED_TO_dc_motor_right_conduit_end_motor_p,               --                dc_motor_right_conduit_end.motor_p
			dc_motor_right_conduit_end_motor_n               => CONNECTED_TO_dc_motor_right_conduit_end_motor_n,               --                                          .motor_n
			epcs_controller_external_dclk                    => CONNECTED_TO_epcs_controller_external_dclk,                    --                  epcs_controller_external.dclk
			epcs_controller_external_sce                     => CONNECTED_TO_epcs_controller_external_sce,                     --                                          .sce
			epcs_controller_external_sdo                     => CONNECTED_TO_epcs_controller_external_sdo,                     --                                          .sdo
			epcs_controller_external_data0                   => CONNECTED_TO_epcs_controller_external_data0,                   --                                          .data0
			reset_reset_n                                    => CONNECTED_TO_reset_reset_n,                                    --                                     reset.reset_n
			sdram_wire_addr                                  => CONNECTED_TO_sdram_wire_addr,                                  --                                sdram_wire.addr
			sdram_wire_ba                                    => CONNECTED_TO_sdram_wire_ba,                                    --                                          .ba
			sdram_wire_cas_n                                 => CONNECTED_TO_sdram_wire_cas_n,                                 --                                          .cas_n
			sdram_wire_cke                                   => CONNECTED_TO_sdram_wire_cke,                                   --                                          .cke
			sdram_wire_cs_n                                  => CONNECTED_TO_sdram_wire_cs_n,                                  --                                          .cs_n
			sdram_wire_dq                                    => CONNECTED_TO_sdram_wire_dq,                                    --                                          .dq
			sdram_wire_dqm                                   => CONNECTED_TO_sdram_wire_dqm,                                   --                                          .dqm
			sdram_wire_ras_n                                 => CONNECTED_TO_sdram_wire_ras_n,                                 --                                          .ras_n
			sdram_wire_we_n                                  => CONNECTED_TO_sdram_wire_we_n                                   --                                          .we_n
		);

